function[nuEcran] = afd(tableau, lblObs, lblVar, nObs, nVar, nLblObs, nuEcran, methode, lst, nomFic, titre, flagLangue)

    getf('val2str.sci');
    getf('traitDonnees.sci');
    getf('plotAdd.sci');
    getf('ficCR.sci');

//  Analyse Factorielle Discriminante

    lstPs = nomFic+'.ps';

//  Prtraitement des donnes

    [clas, nCl, X, R, XI, XJ, CV, A] = traitDonnees(tableau, nObs, nVar, methode, 0);

//  Construction de la matrice des moyennes des variables par classe

    [eff] = zeros(nCl,1);
    [XCJ] = zeros(nVar,nCl);
    for i = 1:nObs
        k = clas(i);
        eff(k) = eff(k) + 1;
        for j = 1:nVar
            XCJ(j,k) = XCJ(j,k) + X(i,j);
        end;
    end;
    aux = diag(eff);
    XCJ = XCJ * (1/aux);
    for j = 1:nVar
        for k = 1:nCl
            XCJ(j,k) = XCJ(j,k) - XI(j);
        end;    
    end;
    CVB = XCJ * diag(sqrt(eff));
    CVB = (1/sqrt(nObs)) * CVB;
    CVDr = CV;
    CV = 1/CV;
    CVV = CVB * CVB';
    CV = CV * CVB;
    E = CVB' * CV;

//  Calcul des valeurs et vecteurs propres

    [valProp, vectProp, info, lblValProp, lblInfo] = valvecP(E, nCl, methode);

//  Vecteurs propres pour l'AFD

    vectPP = CV * vectProp;    

    [valP] = zeros(nCl-1,1);
    [vectP] = zeros(nVar,nCl-1);
    for i = 1:nCl-1;
        valP(i) = valProp(i);
        vectP(:,i) = vectPP(:,i);
    end;

//  Reconstitution du nuage
//  Y pour les observations et Z pour les variables

    cLL = diag(sqrt(valP));
    Z = CVDr * vectP;
    cc = diag(CVV);
    ccd = diag(sqrt(cc));
    Z = (1/ccd) * Z;
    Z = Z * cLL;
    for i = 1:nObs
        for k = 1:nCl-1
            s = 0.0;
            for j = 1:nVar
                s = s + vectP(j,k) * (X(i,j) - XI(j));
            end;
            Y(i,k) = s;
         end;
         if(nCl < 3) then 
             Y(i,k+1) = int16(i/20)+1;
         end;    
     end;   
     if(nCl < 3) then 
         Z = [Z,ones(size(Z,'r'),1)];  
     end;
             
//  Graphiques

    nuEcran = plotAdd(Y,Z,clas,lblVar,lblObs,lblValProp,lblInfo,nObs,nCl,nCl,nuEcran,lstPs,methode,titre);

//  Ecriture du fichier de compte-rendu

    ple = ficCR(Y,Z,clas,XI,CV,R,valP,vectP,info,nObs,nVar,lblVar,lblObs,lblValProp,lblInfo,lst,methode);
    
endfunction      
    
