function[trp] = resRegres(lblObs,lblVar,nObs,nVar,nLblObs,MSEst,MSRes,RMult,RMult2,fRMult2,VRes,VExp,VEst,aEst,SE,intConf,tCoef,yEst,res,nuEcran,regTot, lst, lstPs, titre)

    ddlF1 = nVar;
    ddlF2 = ddl;
    ttr = ' Obs.  ';
    for i = 1:nVar
        ttr = ttr+lblVar(i)+'  ';
    end;
    limLig = 10;
    trp = 1;
    [stu95] = cdft("T",ddl,0.95,0.05);
    [stu99] = cdft("T",ddl,0.99,0.01);
    [fis95] = cdff("F",ddlF1,ddlF2,0.95,0.05);
    [fis99] = cdff("F",ddlF1,ddlF2,0.99,0.01);
    for i = 1:nVar
        tSt(i) = abs(aEst(i+1)/SE(i));
        ind = 0;
        pb = 0;
        while (ind == 0) & (pb < 0.51) 
            pb = pb + 0.01;
            p2 = 0.5 * pb;
            p1 = 1.0 - p2;
            prb = cdft("T",ddl,p1,p2);
            if (tSt(i) >= prb) then
                pSt(i)= pb;
                ind = 1;
            end;
        end;
        if (ind == 0) then pSt(i) = 1; end;
        ind = 0;
        p2 = 0;
        while (ind == 0) & (p2 < 0.51) 
            p2 = p2 + 0.01;
            p1 = 1.0 - p2;
            prb = cdff("F",ddlF1,ddlF2,p1,p2);
            if (tCoef(i) >= prb) then
                pFi(i)= p2;
                ind = 1;
            end;
        end;
        if (ind == 0) then pFi(i) = 1; end;
    end;    
    ind = 0;
    p2 = 0;
    while (ind == 0) & (p2 < 0.51) 
        p2 = p2 + 0.01;
        p1 = 1.0 - p2;
        prb = cdff("F",ddlF1,ddlF2,p1,p2);
        if (fRmult2 >= prb) then
            pRmult2= p2;
            ind = 1;
        end;
    end;
    if (ind == 0) then pRmult2 = 1; end;
    MReg = MSEst - SCE;
    MSReg = MReg/ddlF1;
    
//  Affichage des resultats

        fprintf(%io(2),'%s',titre);
        fprintf(%io(2),'===============================================================');
        fprintf(%io(2),'  ');
        fprintf(%io(2),'REGRESSION MULTIPLE ');
        fprintf(%io(2),'  ');
        fprintf(%io(2),'Nombre d''observations utilisees  %4.0f\n', nObs);
        fprintf(%io(2),'Nombre de variables utilisees    %4.0f\n', nVar+1);
        fprintf(%io(2),'Variable \`a expliquer             %s\n', lblVar(1));
        for i = 1:nVar
            fprintf(%io(2),'%4.0fe variable explicative       %s\n', i, lblVar(i+1));
        end;
        fprintf(%io(2), 'RESULTATS  ');
        fprintf(%io(2),'  ');
        fprintf(%io(2),'Somme totale des carres .................... %12.4f  ', MSEst);
        fprintf(%io(2),'Somme des carres des estimations ........... %12.4f  Carres moyens ... %12.4f',MReg, MSReg);
        fprintf(%io(2),'Somme des carres des ecarts SCE ............ %12.4f  Carres moyens ... %12.4f',SCE, MSRes);
        fprintf(%io(2),'  ');
        fprintf(%io(2),'Coefficient de correlation multiple R ...... %12.4f\n', Rmult);
        fprintf(%io(2),'Carre du coef de correlation multiple R^2 .. %12.4f\n', Rmult2);
        fprintf(%io(2),'Valeur du test F de signification de R^2 ... %12.4f \`a %2.0f et %2.0f ddl Proba d''erreur %4.2f',...
                     fRmult2, ddlF1, ddlF2, pRmult2);
        fprintf(%io(2),'Variances :  residuelle .................... %12.4f',VRes);
        fprintf(%io(2),'             Expliquee ..................... %12.4f',VExp);
        fprintf(%io(2),'             Totale ........................ %12.4f', VEst);
        fprintf(%io(2),'  ');
        fprintf(%io(2),'Coefficients de regression')
        fprintf(%io(2),'  ');
        fprintf(%io(2),'                         Intervalle        Erreur      Test      Proba   Test t( %2.0f ddl)  Proba',ddl);
        fprintf(%io(2),'Var       Coef      de confiance \`a 0.95   standard   partiel F  d''erreur non nullite    d''erreur');
        for i = 1:nVar
            toto = abs(aEst(i+1)/SE(i));
            fprintf(%io(2),'%s   %10.4f  [%8.3f, %8.3f] %10.4f  %10.4f    %4.2f %10.4f %12.2f',...
                  lblVar(i+1), aEst(i+1), aEst(i+1)-intConf(i), aEst(i+1)+intConf(i),SE(i), tCoef(i), pFi(i), tSt(i), pSt(i));
        end;
        fprintf(%io(2),'Terme  ');
        fprintf(%io(2),'constant  %12.4f', aEst(1));
        fprintf(%io(2),'  ');

//  Plot des residus res versus les estimations yEst

        clf(nuEcran);
        xset("window",nuEcran);
        xset("font",4,3);
        pt = 1:nObs;
        x1 = [min(yEst), max(yEst)];
        y1 =[0, 0];

        if (nLblObs == 0) then
            plot2d(yEst, res,[-1, -1],"021");
            xnumb(yEst,res,pt');
        else

//  Plot des residus res versus les estimations yEst
//  Affichage avec des etiquettes alphanumeriques

            plot2d(yEst, res,[-1, -1],"021");
            for i=1:nObs
                xstring(yEst(i), res(i), [lblObs(i)]);
            end;
        end;

        xsegs(x1',y1');
        if (regTot == 1) then
            trt = titre+'  :  Analyse n '+string(nuSeReg);
         else
            trt = titre;
        end;
        resid = lblVar(2);
        if (nVar > 1) then
            for i = 3:nVar+1
                resid = resid +", "+ lblVar(i);
            end;
        end;
        tt = "Residus de la regression des donnees : "+trt;
        xtitle(tt, lblVar(1), resid);
//        xbasimp(nuEcran,lstPs);

//  Ecriture du fichier de compte-rendu

        disp('ECriture du fichier de compte-rendu. Patientez svp.');
        if (regTot == 1) then
            trt = titre+'  :  Analyse n '+string(nuSeReg);
            fprintf(lst,'%s',trt);
        else
            fprintf(lst,'%s',titre);
        end;
        nouvLigne = '\newline';
//        fTex = texprint(titre);
//        fTex = fTex+texprint(nouvLigne);
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','=================================================================================================================');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','REGRESSION MULTIPLE ');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s   %4.0f \n','Nombre d''observations utilisees',nObs);
        writef(lst,'%s   %4.0f \n','Nombre de variables utilisees   ', nVar+1);
        writef(lst,'%s  %s\n','Variable \`a expliquer             ', lblVar(1));
        for i = 1:nVar
            if (nuReg <> i) then
                writef(lst,'%4.0fe variable explicative       %s\n', i, lblVar(i+1));
            end;
        end;
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','_________________________________________________________________________________________________________________');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','RESULTATS DE LA REGRESSION MULTILINEAIRE ');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s \n','                ANALYSE DE LA VARIANCE');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  %12.4f\n', 'Variation totale ........................... ', MSEst);
        writef(lst,'%s  %12.4f',   'Somme des carres des estimations ........... ', MReg);
        writef(lst,'%s  %12.4f\n', ' Carres moyens .... ', MSReg);
        writef(lst,'%s  %12.4f',   'Somme des carres des ecarts SCE ............ ', SCE);
        writef(lst,'%s  %12.4f\n', ' Carres moyens .... ', MSRes);
        writef(lst,'%s  \n','_________________________________________________________________________________________________________________');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s \n','   MESURES GLOBALES DE LA QUALITE DE LA REGRESSION');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s   %12.4f\n','Coefficient de correlation multiple R ...... ', Rmult);
        writef(lst,'%s   %12.4f\n','Carre du coef de correlation multiple R^2 .. ', Rmult2);
        writef(lst,'%s   ','Valeur du test F de signification de R^2 ... ');
        writef(lst,'%12.4f  %s', fRmult2,' \`a ');
        writef(lst,'%4.0f   %s',ddlF1,' et ');
        writef(lst,'%4.0f   %s', ddlF2, ' ddl');
        writef(lst,'%s   %4.2f\n','   Proba d'' erreur',pRmult2);
        writef(lst,'%s  %12.4f\n','Variances :  residuelle .................... ',VRes);
        writef(lst,'%s  %12.4f\n','             Expliquee ..................... ',VExp);
        writef(lst,'%s  %12.4f\n','             Totale ........................ ', VEst);
        writef(lst,'%s  \n','_________________________________________________________________________________________________________________');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s \n','       COEFFICIENTS DE LA REGRESSION');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  %2.0f','                         Intervalle        Erreur      Test      Proba   Test t',ddl); 
        writef(lst,'%s  \n',' ddl  Proba');
        writef(lst,'%s  \n','Var       Coef      de confiance \`a 0.95   standard   partiel F  d''erreur non nullite    d''erreur');
        for i = 1:nVar
            toto = abs(aEst(i+1)/SE(i));
            writef(lst,'%s   %10.4f', lblVar(i+1), aEst(i+1));
            writef(lst,'%s %8.3f %8.3f','  [',aEst(i+1)-intConf(i),aEst(i+1)+intConf(i));
            writef(lst,'%s  %10.4f  %10.4f  %4.2f   %10.4f  %12.2f',']',SE(i),tCoef(i),pFi(i),tSt(i),pSt(i));
            writef(lst,'%s  \n','  ');
        end;
        writef(lst,'%s %12.6f\n', 'Terme constant  ', aEst(1));
        writef(lst,'%s  \n','_________________________________________________________________________________________________________________');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','ANALYSE DES RESIDUS');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','Obs       Valeur      Estimation        Residu');
        for i = 1:nObs
            writef(lst,'%s  %12.4f   %12.4f    %12.4f\n', lblObs(i), y(i), yEst(i), res(i));
        end;
        writef(lst,'%s  \n','  ');
        moyRes = mean(res);
        stRes = st_deviation(res);
        stEst = st_deviation(yEst);
        writef(lst,'%s %12.8f',  'Moyenne des residus = ',moyRes);
        writef(lst,'%s %12.5f\n','   Ecart-type des residus     = ',stRes);
        writef(lst,'%s %12.5f\n','                                      Ecart-type des estimations = ',stEst);
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','  ');
        writef(lst,'%s  \n','=================================================================================================================');

endfunction      

//***********************************************************************************

function[trpIn] = resInitRegres(X, cor, cov, moy, lblObs, lblVar, nObs, nVar, nLblObs, lst, titre);


//  Analyse statistique du tableau des donnees


    limLig = 10;
    if (limLig > nVar) then limLig = nVar;  end;

    fprintf(%io(2),'%s',titre);
    fprintf(%io(2),'===============================================================');
    fprintf(%io(2),'  ');
    fprintf(%io(2),'ANALYSE STATISTIQUE DU TABLEAU DES DONNEES ');
    fprintf(%io(2),'  ');
    fprintf(%io(2),'Nombre d''observations utilisees  %4.0f\n', nObs);
    fprintf(%io(2),'Nombre de variables utilisees    %4.0f\n', nVar);


    writef(lst,'%s  \n','   ');
    writef(lst,'%s  \n','===================================================================================');
    writef(lst,'%s  \n','  ');
    writef(lst,'%s  \n','ANALYSE STATISTIQUE DU TABLEAU DES DONNEES');
    writef(lst,'%s  \n','  ');
    writef(lst,'%s   %4.0f \n','Nombre d''observations utilisees',nObs);
    writef(lst,'%s   %4.0f \n','Nombre de variables utilisees   ', nVar);
    writef(lst,'%s  \n','   ');

    writef(lst,'%s  \n','  ');
    writef(lst,'%s  \n','TABLEAU DES DONNEES');
    writef(lst,'%s  \n','  ');
    writef(lst,'%s  ','No Obs   ');
    for j = 1:nVar
        writef(lst,'%s         ',lblVar(j));       
    end;
    writef(lst,'%s  \n','  ');
    writef(lst,'%s  \n','  ');
    ks = 0;    
    writef(lst,'     %s ', lblObs(1));
    for i = 1:nObs
        for j = 1:nVar
            ks = ks +1;
            writef(lst,'%11.4f  ',X(i,j));
            if (ks == limLig) then
                ks = 0;
                xtit = '    ';
                writef(lst,'%s \n','  ');
                if (j <> nVar+1) then writef(lst,'%s ', xtit); end;
            end;
        end;
        if (ks <> 0) then 
            writef(lst,'%s \n','  '); 
            ks = 0;
        end;
        if (i < nObs) then writef(lst,'%s ', lblObs(i+1)); end;
    end;    
    writef(lst,'%s  \n','  ');

    xvv = '       ';
    for i = 1:nVar
     xvv = xvv +'         '+lblVar(i);
    end;

    writef(lst,'%s  \n','   ');
    writef(lst,'%s  \n',' No  Variable  Moyenne  Ecart-type');
    writef(lst,'%s  \n','  ');
    for i = 1:nVar
        kl = i 
        writef(lst,'%4.0f %s %12.5f %12.5f   \n',kl, lblVar(i),moy(i),sqrt(cov(i,i)));
    end;
    writef(lst,'%s  \n','   ');
    writef(lst,'%s  \n','Matrice des correlations')
    writef(lst,'%s  \n','  ');
    writef(lst,'%s  \n',xvv);
    ks = 0;
    writef(lst,'     %s  ',lblVar(1));
    for i = 1:nVar
        for j = 1:nVar
            xt(j+1) = cor(i,j);
            writef(lst,' %10.4f  ',cor(i,j));
            ks = ks + 1;
            if (ks == limLig) then
                ks = 0
                writef(lst,'%s  \n','    ');
                writef(lst,'%s ','    ');
            end;
        end;
        if (ks <> 0) then
            writef(lst,'%s  \n','    ');
        end;
        if (i < nVar) then writef(lst,'%s  ',lblVar(i+1));  end;
    end;
    writef(lst,'%s  \n','   ');

    trpIn = 1;

endfunction      
    
      
    
